// Subscriber numbers are computed in the Youtuber class and used to create new SubBars

class SubBars{
  float x; // x coord
  float y; // y coord
  float w; // width
  float h; // scaling height
  float h2; // final height
  color channelC; // Channel color
  color c; // Bar color
  String content; // what kind of bar it is (high, low, average, channel)

  float subScale; // ratio to scale down the sub count
  float barStart; // where the sub bars start (y coord)
  float barWidth; // sub bar width + spacing
  
  float subCounter;
  
  Tooltip subTooltip; // subscription tooltip

  int subInt; // converts floats to ints so they can be used with nfc()
  String subString; // uses nfc() to add commas in proper spots

  float speed = 15;

  SubBars(int barNumber, float subCount, String tempcontent){
    
    barStart = 600 - transX;
    barWidth = 45;
    subCounter = subCount;
    subScale = 20000;
    
    x = barStart-(barWidth*barNumber);
    y = height-transY-40;
    h = 0; // scaling height
    h2 = -(subCounter/subScale); // final height
    w = 10;
    //channelC = tempc;
    content = tempcontent;
    
    subInt = int(subCounter);
    subString = nfc(subInt);
    
    if (content.equals("Lowest") || content.equals("Highest") || content.equals("Average")){
      c = lightGray;
    } else if (content.equals("Channel")){
      c = vlogC; // temp color
    }
  
    subTooltip = new Tooltip(x, mouseY, (" " + content + " Sub Count: " + subString + " "), "right");
  
  }

  void display(){
    if (anyClicked == true) { // if any channels are selected
      // Declare again for changing variables
      h2 = -(subCounter/subScale); 
      subInt = int(subCounter);
      subString = nfc(subInt);
      subTooltip.tipText = (content + " Sub Count: " + subString);
      subTooltip.tipWidth = (textWidth(subTooltip.tipText)) + 20;
    
    // adjust for sub bars that go off the chart
    if (subCounter > 9000000) {
      h2 = -710-((subCounter/subScale)/50);
    }
    // adjust for sub bars that don't even show, they're so small
    if (subCounter < 1000){
      h2 = 1;
    }
    
      fill(c);
      noStroke();
      rectMode(CORNER);
      rect(x, y, w, h);
      // if sub bar goes off chart, draw cut-off line
      if (subCounter > 9000000) {
        stroke(#ffffff);
        strokeWeight(5);
        strokeJoin(MITER);
        beginShape();
        vertex(x-1, (y+h2+20));
        vertex((x+w+2), (y+h2+25));
        endShape();
      }
      
      textAlign(CENTER);
      textFont(av12Font);
      text(content.toLowerCase(), (x+w/2), (y+h-5));
    
      animate();
    
      subTooltip.display();
      // update tooltip Y
      subTooltip.y = mouseY - transY - 25;
    
    }
  
    // Mouse needs a little extra room to hover for the really skinny bars
    if (mouseX > (x+transX)){
      if (mouseX < x+w+transX) {
       if (mouseY > y+h+transY-5) {
         if (mouseY < y+transY+5){
           // hovering
           onHover();
         } else {offHover();}
       } else {offHover();}
      } else {offHover();}
    } else {offHover();}
    
  }
  
  void onHover(){
    subTooltip.onHover(); 
  }
  
  void offHover(){
    subTooltip.offHover();
  }
  
  void animate(){
    // animate bar, slow down according to the distance
    if (h > h2) {
      float distY = h-h2;
      h = h - distY/8;
    }
    if (h < h2) {
      float distY = h2-h;
      h = h + distY/8;
    }
 
  }



}
