import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class youtube_rewind_jbarkun extends PApplet {


// COLORS
int vlogC = 0xff47C0B9; // 1
int cookingC = 0xff35C0CC; // 2
int gamerC = 0xff29AED1; // 3
int musicC = 0xff3299CC; // 4
int danceC= 0xff3781C4; // 5
int entC= 0xff4071B7; // 6
int otherC = 0xff455CAA; // 7
int titleC; // Default color
int darkGray = 0xff58595B; // Dark Gray Color
int lightGray = 0xff808285; // Light gray color
int lightGray2 = 0xffE0E0E0;

// XML & YOUTUBERS
XML root;
XML[] channels;
XML cTitleElement;
XML cNameElement;
XML cCategoryElement;
XML[] cCList;
XML[] allSubCountsElement;
int[] allSubCounts;
XML cSubsElement;
int cSubs;
String[] cConnect;
String cTitle;
String cName;
String cCategory;
Youtuber[] channelObjects;
ArrayList<Connection> connectionLines;
XML[] connectTitlesElement; // List of all titles for the purpose of connections
String[] connectTitles; // Compiled into strings
int tierLevel; // Finds the tier level of each connection
StringList cConnectString; // list of all the connection strings
XML cMostWatchedElement;
String cMostWatched;
String cMostWatchedViews;
String cMostWatchedURL;

// YOUTUBER IMAGES
XML cImageElement;
String cImage;

// COUNTERS
Counter youtubersCounter;

// Instructions
Instructions instructions;

// SUB BARS
SubBars lowSubBar; // low sub count bar
SubBars averageSubBar; // average sub count bar
SubBars channelSubBar; // channel's sub count bar
SubBars highSubBar; // high sub count bar
float subs;
float subLow; // Lowest sub count
float subHigh; // Highest sub count
float subAverage; // Average sub count

// FONTS
PFont titleFont; // Title Line
PFont nameFont; // Name Line && Counter Numbers
PFont av12Font; // Size 12 font
PFont av12BoldFont; // Size 12 font bold
PFont av18Font; // Size 18 bold font

// Beginning test
String startText1 = "What does 2013 Say?";
String startText2 = "Youtube Rewind";
float startTitleTextY;
float startTitleTextY2;
float titleTextY = 720; // final text position
float titleTextY2 = height+100; // Offscreen position
boolean moveTitle = false;

// OTHER VARIABLES
float radius;
int numChannels;
float angle;
float transX;
float transY;
boolean anyClicked = false; // Check to see if any of the channels are clicked
boolean anyHover = false; // Check to see if any of the channels is hovered on

public void setup(){
  size(1400,800);
  frameRate(30);
  noStroke();
  
  //FONTS
  titleFont = loadFont("Rancho-36.vlw");
  nameFont = loadFont("Gudea-20.vlw");
  av12Font = loadFont("Gudea-12.vlw");
  av12BoldFont = loadFont("Gudea-Bold-12.vlw");
  av18Font = loadFont("Gudea-Bold-14.vlw");
  
  
  // SET UP YOUTUBERS
  root = loadXML("youtubers.xml"); // Load XML File
  channels = root.getChildren("channel"); // Put all channels into array
  channelObjects = new Youtuber[channels.length]; // Make an array of youtubers with how many are in the xml
  connectionLines = new ArrayList<Connection>(); // Make an expandable array for the connection lines
  
  allSubCountsElement = root.getChildren("channel/subs"); // Get all subscriber counts for high, low and average
  allSubCounts = new int[allSubCountsElement.length];
  for (int k = 0; k < allSubCountsElement.length; k++){
    allSubCounts[k] = allSubCountsElement[k].getIntContent();
  }
  
  
  // OTHER VARIABLES
  transX = 975;
  transY = 350;
  radius = 280; // circle radius
  angle=TWO_PI/(float)channels.length; // angle each circle needs to go
  // for sub bars
  subLow = min(allSubCounts); 
  subHigh = max(allSubCounts);
  float average = 0; // Compute the average
   for ( int i = 0; i < allSubCounts.length; i++ ) { 
     subAverage += allSubCounts[i]; 
   } 
   subAverage /= (float)(allSubCounts.length); 
   subs = 0; // temp number
   cConnectString = new StringList();
   startTitleTextY = 720;
   startTitleTextY2 = height+100;
   
  
  // OTHER OBJECTS
  youtubersCounter = new Counter("youtubers");
  instructions = new Instructions();
  lowSubBar = new SubBars(0, subLow, "Lowest");
  averageSubBar = new SubBars(1, subAverage, "Average");
  channelSubBar = new SubBars(2, subs, "Channel");
  highSubBar = new SubBars(3, subHigh, "Highest");

     // SET UP CONNECTIONS
   connectTitlesElement = root.getChildren("channel/title");
   connectTitles = new String[connectTitlesElement.length];
   for (int n=0; n < connectTitlesElement.length; n++){
     connectTitles[n] = connectTitlesElement[n].getContent();
   }

  // SET UP YOUTUBERS PART 2
  for (int i = 0; i < channels.length; i++) {
    cTitleElement = channels[i].getChild("title");
    cTitle = cTitleElement.getContent();
    cNameElement = channels[i].getChild("name");
    cName = cNameElement.getContent();
    cCategoryElement = channels[i].getChild("category");
    cCategory = cCategoryElement.getContent();
    cImageElement = channels[i].getChild("img");
    cImage = cImageElement.getContent();
    cCList = channels[i].getChildren("connectList/connect"); // Gets connectList
    cConnect = new String[cCList.length];
    cSubsElement = channels[i].getChild("subs"); // gets subscriber count
    cSubs = cSubsElement.getIntContent();
    cMostWatchedElement = channels[i].getChild("watched"); // most watched
    cMostWatched = cMostWatchedElement.getContent();
    cMostWatchedViews = cMostWatchedElement.getString("views");
    cMostWatchedURL = cMostWatchedElement.getString("url", "blank");
    
    for (int k = 0; k < cCList.length; k++){
      cConnect[k] = cCList[k].getContent(); // Found the connections and converted them to strings
      tierLevel = cCList[k].getInt("tier"); // Gets the tier level of the connection
      
      for (int m=0; m < connectTitles.length; m++) { // Run through each channel title for a match
        if (cConnect[k].equals(connectTitles[m])){
          connectionLines.add(new Connection(i, m, tierLevel, cCategory)); // add a new connection line 
        } else { }
      } 
    }
    channelObjects[i] = new Youtuber(radius*sin(angle*i), -(radius*cos(angle*i)), cTitle, cCategory, cName, cImage, cSubs, cConnect, cMostWatched, cMostWatchedViews, cMostWatchedURL); 
  }
   
   // DEFAULT TEXT
  titleC = gamerC; // Default color
   
   // Adjust connection lines
  for (int i = 0; i < channels.length; i++) {
    channelObjects[i].xpos2 = channelObjects[i].xpos;
    channelObjects[i].ypos2 = channelObjects[i].ypos;
  }

}

public void draw(){
  background(255);
  fill(0xffeeeeee);
  rectMode(CORNER);
  rect(0, 0, 350, 75);
  stroke(0xffdbdbdc);
  strokeWeight(5);
  line(350, 0, 350, height);
  pushMatrix();
  translate(transX, transY); // center of circle
  anyHover = false;
  
  // DISPLAY CONNECTIONS
  for (int i=0; i < connectionLines.size(); i++){
    Connection connection = connectionLines.get(i);
    connection.display();
  }
    
  // DISPLAY YOUTUBERS
  for (int i = 0; i < channels.length; i++) {
    channelObjects[i].display();
  }
  // Go back and display any showing tooltips again to keep them above the circles
  for (int i = 0; i < channels.length; i++){
    channelObjects[i].showTip();
  }
  
  for (int i = 0; i < channels.length; i++) {
   // Check to see if any channels are clicked
    if (channelObjects[i].ifClicked == true) {
      anyClicked = true;
      cConnectString.clear(); // erase all current connections
      // If a channel is clicked, hide all connections that aren't with that channel
      for (int k = 0; k < connectionLines.size(); k++){
        Connection connection = connectionLines.get(k);
        if (connection.person1 != i) {
          if (connection.person2 != i) {
             connection.showConnection = false;
          }
        } 
         // if a connection is showing, add it to the cConnectString stringlist 
         if (connection.showConnection == true) {
           if (connection.person1 != i) {
             cConnectString.append(channelObjects[connection.person1].title);
           } else {
             cConnectString.append(channelObjects[connection.person2].title);
           }
         }
      }
    } else { }
   // Check to see if any channels has hover on
   if (channelObjects[i].ifHovered == true) {
      anyHover = true;
    } else {}
  }
  // if no channels are clicked, have cConnectString show full youtuber list instead
  if (anyClicked == false) {
    cConnectString.clear(); // remove any strings in the list
    for (int i = 0; i < channels.length; i++) {
      cConnectString.append(channelObjects[i].title);
    }
  }
  
  
  // adjust channel sub value
  for (int i = 0; i < channels.length; i++){
    if (channelObjects[i].ifClicked == true){
      channelSubBar.subCounter = channelObjects[i].cSubs;
      channelSubBar.c = channelObjects[i].c;
    }
  }
  // draw sub bars but don't display until channel is selected
  highSubBar.display();
  channelSubBar.display();
  averageSubBar.display();
  lowSubBar.display();
  //draw subbar title text once channel is selected
  if(anyClicked == true){
    textFont(av18Font);
    for (int i = 0; i < channels.length; i++){
      if (channelObjects[i].ifClicked == true) {
        fill(channelObjects[i].c);
      }
    }
    textAlign(CENTER);
    text("Subscriber Counts", (channelSubBar.x+(channelSubBar.barWidth/2)), (height-transY-20));
  }
  
  popMatrix();
  
  // DISPLAY TEXT
  textFont(titleFont);
  textAlign(CENTER);
  fill(titleC);
  rectMode(CORNER);
  text(startText1.trim(), transX, startTitleTextY); // Title Text
  textFont(nameFont);
  fill(darkGray);
  text((startText2.trim()), transX, startTitleTextY+30); // Name Text

  // animate text out on click
  if (anyClicked == true){
    float distY = startTitleTextY2 + startTitleTextY;
    if (startTitleTextY < startTitleTextY2) {
      startTitleTextY = startTitleTextY + distY/8;
    }
  }  else {
    // animate text back in off click
    float distY = 720 - startTitleTextY;
    if (startTitleTextY > 720) {
      startTitleTextY = startTitleTextY + distY/4;
    }
  }
  
  // DISPLAY YOUTUBER COUNT
  youtubersCounter.display();
  
  // display instructions
  instructions.display();
  
  
}
class CatLegend{
  float x;
  float y;
  float d;
  int c;
  float alpha;
  String type;
  Tooltip catTip;
  
  float distX;
  float distY;
  
  boolean catOn = false;

  CatLegend(float tempnumber, int tempc, float tempx, float tempy){
    y = tempy;
    d = 15; // diameter
    x = tempx+d/2+(tempnumber*23); // tempnumber should start at 0
    c = tempc;
    alpha = 255;
    
    if (c == vlogC){
      type = "Vlogger";
    } else if (c == cookingC){
      type = "Cooking";
    } else if (c == gamerC){
      type = "Gamer";
    } else if (c == musicC){
      type = "Musician";
    } else if (c == danceC){
      type = "Dancer";
    } else if (c == entC){
      type = "Entertainment";
    } else if (c == otherC){
      type = "Other";
    } else{
      type = "All";
    }
    
    catTip = new Tooltip(x, y-20, type, "center");
  
  }
  
  
  public void display(){
    fill(c, alpha);
    
    if (type.equals("All")){
      strokeWeight(1);
      stroke(lightGray, alpha);
    } else {
      noStroke();
    }
    
    ellipseMode(CENTER);
    ellipse(x, y, d, d);
    
    // CHECK FOR HOVER
    distX = sq(x - mouseX);
    distY = sq(y- mouseY);
    if ((distX + distY) <= sq(d/2)){
      catOn = true;
      onHover();
    } else {
      catOn = false;
      offHover();
    }
    if (alpha == 255) {
      catTip.display();
    }
    
  }
  
  public void onHover(){
    catTip.onHover();
  }
  
  public void offHover(){
    catTip.offHover();
  }



}
//Code for connecting lines
class Connection{
  int person1;
  int person2;
  int c;
  float tier;
  float tierStroke;
  float tier1 = 1; // cameos
  float tier2 = 0.5f; // related material
  
  boolean showConnection; // Whether to show the connection or not
  float dist; // distance between points for curve
  
  Connection(int tempperson1, int tempperson2, float temptier, String tempc){
    person1 = tempperson1;
    person2 = tempperson2;
    showConnection = true;
    tier = temptier;
    
    if (tier == 1) {
      if (tempc.equals("vlog")){
        c = vlogC;
      } else if (tempc.equals("cooking")){
        c = cookingC;
      } else if (tempc.equals("gamer")){
        c = gamerC;
      } else if (tempc.equals("music")){
        c = musicC;
      } else if (tempc.equals("dance")){
        c = danceC;
      } else if (tempc.equals("ent")){
        c = entC;
      } else if (tempc.equals("other")){
        c = otherC;
      } else {
        c = 0xff000000;
      }
    } else if (tier == 2) {
      c = 0xffCCD9E3;
    } else {
    }
  
  }
  
  
  public void display(){
      if (showConnection == true) { // Only show if showConnection is true
        noFill();
        strokeWeight(0.8f);
        stroke(c);
     
         dist = (dist(channelObjects[person1].xpos2, channelObjects[person1].ypos2, channelObjects[person2].xpos2, channelObjects[person2].ypos2))/2;
         bezier(channelObjects[person1].xpos2, channelObjects[person1].ypos2, (radius-dist)*sin(angle*person1), -((radius-dist)*cos(angle*person1)), (radius-dist)*sin(angle*person2), -((radius-dist)*cos(angle*person2)), channelObjects[person2].xpos2, channelObjects[person2].ypos2 );
      } 
  }


}

class Counter{
  int number; // whatever number is inside the counter
  String type; // Whether the counter is for youtubers or references
  String underText; // The text that goes under the counter
  float x; // the x coordinate (changes)
  float y; // the y coordinate (doesn't change)
  float d; // diameter
  float d2; // diameter of stroked circle
  int numConnections; // Number of connections for each channel
  
  String[] list; // list of strings to display
  
  float distX;
  float distY; 
  
  int c; // color pulled from rest of sketch
  String hexColor; // hex color string
  int intColor; // hex color converted to int
  int r;
  int g;
  int b;
  int speed; // speed of animation

  float stringX; // x coord of strings
  float stringX2; // second row of strings for long lists

  Counter(String temptype){
    type = temptype;
    y = 35;
    d = 30;
    d2 = d-2;
    numConnections = 0;
    underText = type;
    r = 88;
    g = 89;
    b = 91;
    speed = 15;
    distX = 0;
    distY = 0;
    stringX = -300;
    
  }

  public void display(){
    
    hexColor = hex(c);
    intColor = unhex(hexColor);
    
    numConnections = 0;
    stringX2 = stringX + 160; // declare in display for animation
    
    if(type.equals("youtubers")){
      x = 35;
      if (anyClicked == false) { // Show overall counts on start
        number = channels.length;
        underText = type;
      } else { // switch to individual connections on detail view
        underText = "connections"; // change underText to connections
        for (int i = 0; i < channels.length; i++) {
          if (channelObjects[i].ifClicked == true) {
            for (int k = 0; k < connectionLines.size(); k++){
              Connection connection = connectionLines.get(k);
              if (connection.person1 == i) { 
                numConnections++;
              } 
              if (connection.person2 == i) {
                numConnections++;
              }
            } 
          }
        }
        number = numConnections;
      }
    } else if (type.equals("references")){
      x = 175;
      if (anyClicked == false) {
        number = 10; // replace with reference length once it's set up
      } else{
        number = 5; // replace with individual references once it's set up
      }
    }
    strokeWeight(1);
    ellipseMode(CENTER);
    fill (0xffffffff);
    stroke(r, g, b);
    ellipse(x, y, d2, d2);
    fill(r, g, b);
    noStroke();
    ellipse(x, y, d, d);
    fill(darkGray);
    textFont(av12Font);
    textAlign(LEFT, CENTER);
    text(underText, x+d-5, y);
    textFont(av18Font);
    fill(0xffffffff);
    textSize(14);
    textAlign(CENTER, CENTER);
    text(number, x, y);
    
    textFont(av12Font);
    textAlign(LEFT);
    fill(darkGray);
        
    if (cConnectString.size() <= 38) {
      for (int k = 0; k < cConnectString.size(); k++){
       String connectString = cConnectString.get(k);
       text(connectString, stringX, 100+(16*k));
      }
    } else {
      for (int k = 0; k < 38; k++){
       String connectString = cConnectString.get(k);
       text(connectString, stringX, 100+(16*k));
      }
      for (int k = 38; k < cConnectString.size(); k++){
       String connectString = cConnectString.get(k);
       text(connectString, stringX2, 100+(16*(k-38)));
      }
    
    }
    
    // NEW METHOD OF CHECK FOR HOVER
    distX = sq(x - mouseX);
    distY = sq(y - mouseY);
    if ((distX + distY) <= sq(d/2)){
      onHover();
    } else {
      offHover();
    }
    
  }

  public void onHover() {
    // GET HOVER COLOR
    c = titleC;
    
    // Change background color to cyan on hover
      if (r > ((intColor >> 16) & 0xFF)) {
        r = r - speed;
      }
      if (r < ((intColor >> 16) & 0xFF)) {
        r = r + speed;
      }
      if (g > ((intColor >> 8) & 0xFF)) {
        g = g - speed;
      }
      if (g < ((intColor >> 8) & 0xFF)) {
        g = g + speed;
      }
      if (b > (intColor & 0xFF)) {
         b = b - speed;
      }
      if (b < (intColor & 0xFF)) {
         b = b + speed;
      }
    // Expand second circle behind
    if (d2 < 35) {
        d2 = d2 + (speed/5);
      }  
      
      if(type.equals("youtubers")){
        // animate strings in
        if (stringX < 25) {
          float stringDistX = stringX - 25;
          stringX = stringX - stringDistX/4;
        } 
      }
      
  }
  
  public void offHover() {
    c = darkGray;

    // Change background color back to gray off hover
      if (r > ((intColor >> 16) & 0xFF)) {
        r = r - speed;
      }
      if (r < ((intColor >> 16) & 0xFF)) {
        r = r + speed;
      }
      if (g > ((intColor >> 8) & 0xFF)) {
        g = g - speed;
      }
      if (g < ((intColor >> 8) & 0xFF)) {
        g = g + speed;
      }
      if (b > (intColor & 0xFF)) {
         b = b - speed;
      }
      if (b < (intColor & 0xFF)) {
         b = b + speed;
      }
      // Hide stroked circle
      if (d2 > d-2) {
        d2 = d2 - (speed/5);
      }  
      
      if(type.equals("youtubers")){
        // animate strings out
        if (stringX > -300) {
          float stringDistX = stringX - 40;
          stringX = stringX + stringDistX/2;
        } 
      }

  }
  


}
class Instructions{
  float x;
  float finalx; // where the instructions should end up; x values are right-aligned
  float offscreenx; // where the instructions will stop off-screen
  float y; // top alignment
  float w; // text box widths
  float space; // spacing between paragraphs
  float leading; // leading between lines
  float sWeight; // stroke weight for connection legend
  
  float caty;
  CatLegend catVlog;
  CatLegend catCooking;
  CatLegend catGamer;
  CatLegend catMusic;
  CatLegend catDance;
  CatLegend catEnt;
  CatLegend catOther;
  CatLegend catAll;
  
  Tooltip lineTier1;
  Tooltip lineTier2;
  Tooltip lineTierAll;
  Tooltip rewindTip;
  float line1y;
  float line2y;
  float lineally;
  
  boolean tierAllOn = true;
  boolean tier1On = false;
  boolean tier2On = false;
  boolean rewindOn = false;

  Instructions(){
    finalx = 375;
    offscreenx = -450;
    x = 375;
    y = -50;
    w = 400; // negative for right alignment
    space = 20;
    leading = 14;
    sWeight = 2;
    lineally = y+20+(12*3)+space+30+12+12+space+40;
    line1y = y+20+(12*3)+space+30+12+12+space+40+10;
    line2y = y+20+(12*3)+space+30+12+12+space+40+20;
    
    caty = y+20+(12*3)+space+40;
    
    // declared in display so that they move off-screen with rest of instructions
    catVlog = new CatLegend(0, vlogC, x, caty);
    catCooking = new CatLegend(1, cookingC, x, caty);
    catGamer = new CatLegend(2, gamerC, x, caty);
    catMusic = new CatLegend(3, musicC, x, caty);
    catDance = new CatLegend(4, danceC, x, caty);
    catEnt = new CatLegend(5, entC, x, caty);
    catOther = new CatLegend(6, otherC, x, caty);
    catAll = new CatLegend(7, 0xffffffff, x, caty);
    
    lineTierAll = new Tooltip(x+50, lineally-10, "All Connections", "center");
    lineTier1 = new Tooltip(x+50, line1y-10, "Direct Connections", "center");
    lineTier2 = new Tooltip(x+50, line2y-10, "Related Material", "center");
    rewindTip = new Tooltip(x+38, y+230, "Watch Youtube Rewind 2013", "center");
  
  }
  
  public void display(){
    
    textAlign(LEFT, TOP);
    rectMode(CORNER);
    textFont(av18Font);
    fill (titleC);
    //text("Instructions", x, y);
    text("Categories", x, y+20+(12*3)+space);
    text("Connections", x, y+20+(12*3)+space+30+12+12+space);
    textFont(av12Font);
    textLeading(leading);
    fill(darkGray);
    //text("Click on any of the youtubers to learn more about them. Hover for names and values. Youtubers are ordered according to appearance in Youtube Rewind, starting with Kid President and ending with Pewdiepie.", x, y+20, w, 100);
    text("Click to isolate a category.", x, y+20+(12*3)+space+15);
    text("Click to isolate a connection level.", x, y+20+(12*3)+space+30+12+12+space+15);
    text("Source: All data was taken from Youtube on February 24, 2014.", x, height-40, w, 100);

    // category circles
    catVlog.display();
    catCooking.display();
    catGamer.display();
    catMusic.display();
    catDance.display();
    catEnt.display();
    catOther.display();
    catAll.display();
    
    // connection lines legend
    strokeWeight(sWeight);
    strokeCap(SQUARE);
    stroke(titleC);
    line(x, lineally, x+20, lineally);
    stroke(lightGray);
    line(x+20, lineally, x+40, lineally);
    stroke(titleC);
    line(x+40, lineally, x+60, lineally);
    stroke(lightGray);
    line(x+60, lineally, x+80, lineally);
    stroke(titleC);
    line(x+80, lineally, x+100, lineally);
    stroke(titleC);
    line(x+0, line1y, x+100, line1y);
    stroke(lightGray);
    line(x+0, line2y, x+100, line2y);
    
    lineTierAll.display();
    lineTier1.display();
    lineTier2.display();
    
    // check for line legends hover
    if (mouseX > x && mouseX < x+100){
      if (mouseY > lineally-2 && mouseY < lineally+sWeight+2){
        tierAllOn = true;
        tier1On = false;
        tier2On = false;
        lineTierAll.onHover();
        lineTier1.offHover();
        lineTier2.offHover();
      }else if (mouseY > line1y-2 && mouseY < line1y+sWeight+2) {
        // if hovering on first line
        tierAllOn = false;
        tier1On = true;
        tier2On = false;
        lineTierAll.offHover();
        lineTier1.onHover();
        lineTier2.offHover();
      } else if (mouseY > line2y-2 && mouseY < line2y+sWeight+2) {
        // if hovering on second line
        tierAllOn = false;
        tier2On = true;
        tier1On = false;
        lineTierAll.offHover();
        lineTier2.onHover();
        lineTier1.offHover();
      } else {
        tierAllOn = false;
        tier1On = false;
        tier2On = false;
        lineTierAll.offHover();
        lineTier2.offHover();
        lineTier1.offHover();
      }
    } else {
      tierAllOn = false;
      tier1On = false;
      tier2On = false;
      lineTierAll.offHover();
      lineTier2.offHover();
      lineTier1.offHover();
    }
    
    //check to see if channels are clicked
    if (anyClicked == true) {
      offScreen();
    } else {
      onScreen();
    }
    
    // rewind button
    float triStartX = x+12;
    float triStartY = y+258;

    fill(titleC);
    rectMode(CORNER);
    rect(x, y+240, 65, 37, 10);
    fill(0xffffffff);
    triangle(triStartX, triStartY, triStartX+15, triStartY-8, triStartX+15, triStartY+8);
    triangle(triStartX+20, triStartY, triStartX+15+20, triStartY-8, triStartX+15+20, triStartY+8);
  
    rewindTip.display();
  
    // check for rewind button hover
    if (mouseX > x && mouseX < x+65 && mouseY > y+240 && mouseY < y+320){
      rewindOn = true;
      rewindTip.onHover();
    } else {
      rewindTip.offHover();
      rewindOn = false;
    }
  
  }


  public void offScreen(){
    float distX = x + offscreenx;
    if (x > offscreenx) {
      x = x + distX/8;
    }
    catVlog.alpha = 0;
    catCooking.alpha = 0;
    catGamer.alpha = 0;
    catMusic.alpha = 0;
    catDance.alpha = 0;
    catEnt.alpha = 0;
    catOther.alpha = 0;
    catAll.alpha = 0;
    
  }

  public void onScreen(){
    float distX = finalx - x;
    if (x < finalx) {
      x = x + distX/4;
    }
    catVlog.alpha = 255;
    catCooking.alpha = 255;
    catGamer.alpha = 255;
    catMusic.alpha = 255;
    catDance.alpha = 255;
    catEnt.alpha = 255;
    catOther.alpha = 255;
    catAll.alpha = 255;
    
  }

}

class Tooltip{
  String tipText; // what goes in the tooltip
  float tipWidth; // width of title
  float alpha; // alpha value for tooltip hover
  float x; // x coordinate
  float y; // y coordinate
  float speed; // speed of fade
  String align; // how the tooltip needs to be aligned relative to it's content
  boolean alignToMouse;
  
  Tooltip(float tempx, float tempy, String temptext, String tempalign){
    y = tempy-10;
    tipText = temptext;
    speed = 25;
    align = tempalign;
    tipWidth = (textWidth(tipText)) + 50;
    
    if (y == mouseY) {
      alignToMouse = true;
    }
    
    if (align.equals("right")) {
      x = tempx - (tipWidth/2);
    }
    if (align.equals("center")) {
      x = tempx;
    }
    if (align.equals("left")) {
      x = tempx + (tipWidth/2);
    }
  
  }

  public void display(){
      // update mouse position
      if (alignToMouse == true) {
        y = mouseY - transY;
      }
    
     textFont(av18Font);
     fill(0xffeeeeee, alpha);
     noStroke();
     rectMode(CENTER);
     rect(x, y, tipWidth, 30);
     fill(0xff282828, alpha);
     textAlign(CENTER, CENTER);
     text(tipText, x, y);
  
  }
  
  public void onHover(){
    // fade tooltip in
    if (alpha < 255) {
      alpha = alpha + (speed*1.5f);
     }
    if (alpha > 255) {
      alpha = 255;
    }
  }
    
  public void offHover(){
    // fade tooltip out
    if (alpha > 0) {
      alpha = alpha - speed;
    } if (alpha < 0){
      alpha = 0;
    }
  }
  

}


// CLASS FOR YOUTUBER CIRCLES
class Youtuber{
  float xpos; // x coordinate
  float ypos; // y coordinate
  float r2=15; // radius
  String title; // Youtuber's title
  float titleWidth; // width of title
  String name; // Youtube's second title and/or name
  
  float cSubs; // channel sub count
  
  int c; // circle color
  int c2; // color copy for title text
  float alpha; // alpha value for channel circle
  String hexColor; // hex color string
  int intColor; // hex color converted to int
  int r;
  int g;
  int b;
  int speed; // speed of animation
  
  boolean ifClicked; // check if this channel is clicked
  boolean ifHovered; // check if this channel has hover on
  boolean clickable; // can toggle if anything can be clicked or not
  boolean reverse = false; // if the alpha needs to be lowered or not
  PImage image; // Youtuber image
  float imageSize = 0; // Initial image width&height before scaling
  float imageSize2 = 280; // Final image size
  
  float xpos2; // x coordinate for connections
  float ypos2; // y coordinate for connections
  float xposi; // x coordinate for the image center;
  float yposi; // y coordinate for the image center;
  
  float distX;
  float distY; 
  
  float mostWatchedX = -transX-500;
  float mostWatchedX2 = 40-transX; // final position
  float mostWatchedY = height-transY-170;
  String mostWatchedName;
  String mostWatchedViews;
  String URL;
  
  float titleY = height-transY+100;
  float titleY2 = 720-transY;
  
  String[] connects; // string list of connections

  Tooltip cTooltip; // channel tooltip
  ReturnBtn returnBtn;
  
  Youtuber(float tempxpos, float tempypos, String temptitle, String tempc, String tempname, String tempimg, int tempsubs, String[] tempconnects, String tempmostwatched, String tempmostwatchedviews, String tempurl){
    xpos = tempxpos;
    ypos = tempypos;
    xpos2 = xpos;
    xpos2 = ypos;
    title = temptitle; 
    name = tempname;
    ifClicked = false;
    ifHovered = false;
    clickable = true;
    image = loadImage(tempimg);
    connects = tempconnects;
    mostWatchedName = tempmostwatched;
    mostWatchedViews = tempmostwatchedviews;
    URL = tempurl;
    
    alpha = 255;
    
    cTooltip = new Tooltip(xpos, ypos-r2-5, title, "center");
    
    cSubs = tempsubs;
    
    xposi = 0;
    yposi = 0;
    speed = 15;
    distX = 0;
    distY = 0;
    
    if (tempc.equals("vlog")){
      c = vlogC;
    } else if (tempc.equals("cooking")){
      c = cookingC;
    } else if (tempc.equals("gamer")){
      c = gamerC;
    } else if (tempc.equals("music")){
      c = musicC;
    } else if (tempc.equals("dance")){
      c = danceC;
    } else if (tempc.equals("ent")){
      c = entC;
    } else if (tempc.equals("other")){
      c = otherC;
    } else {
      c = 0xff000000;
    }
    
    returnBtn = new ReturnBtn(c);
    
    hexColor = hex(c);
    intColor = unhex(hexColor);
    
    r = ((intColor >> 16) & 0xFF);
    g = ((intColor >> 16) & 0xFF);
    b = ((intColor >> 8) & 0xFF);
    
  }
  

  public void display(){
    smooth();
    if (reverse == true) {
      noStroke();
      fill(lightGray2, alpha);
    } else {
      noStroke();
      fill(c, alpha);
    }
    ellipse(xpos, ypos, r2, r2);
    
    hexColor = hex(c);
    intColor = unhex(hexColor);
    c2 = (color(r,g,b));

    // CHECK FOR HOVER
    distX = sq(xpos+transX - mouseX);
    distY = sq(ypos+transY - mouseY);
    if ((distX + distY) <= sq(r2/2)){
      onHover();
      ifHovered = true;
    } else {
      offHover();
    }
    
    active();
    titleText();
    mostWatched();
        
   }
   
  public void showTip(){
    cTooltip.display();
  }
  
  public void onHover(){
    textAlign(RIGHT);
    if (anyClicked == false){
      titleC = (c2);
    }
    // Change text color to current category on hover
      if (r > ((intColor >> 16) & 0xFF)) {
        r = r - speed;
      }
      if (r < ((intColor >> 16) & 0xFF)) {
        r = r + speed;
      }
      if (g > ((intColor >> 8) & 0xFF)) {
        g = g - speed;
      }
      if (g < ((intColor >> 8) & 0xFF)) {
        g = g + speed;
      }
      if (b > (intColor & 0xFF)) {
         b = b - speed;
      }
      if (b < (intColor & 0xFF)) {
         b = b + speed;
      }
      c2 = (color(r,g,b));
      cTooltip.onHover(); //tooltip hover
      
  }
    
  public void offHover(){
    ifHovered = false;
    cTooltip.offHover();
  }
  
  public void onClick(){
    if (anyClicked == true){
      anyClicked = false; // If something was already clicked, reset to defaults
    } else {
      ifClicked = true;
      clickable = false; // makes it so nothing can be clicked  
    }
  }

  public void active(){
    imageMode(CENTER);
    image(image, xposi, yposi, imageSize, imageSize);

    if (ifClicked == true) { // if channel is selected
      // control connect lines
      xpos2 = xposi; 
      ypos2 = yposi;
      // animate image in
      float imageDist = imageSize2 - imageSize;
      if (imageSize < imageSize2) {
        imageSize = imageSize + imageDist/8;
      }
      if (imageSize > imageSize2-3) {
        imageSize = imageSize2;
        // show return button
        returnBtn.display();
      }
      // dim alpha channel
      alpha = 100;
      
    }
    if (ifClicked == false){ // if channel isn't selected
      // fix connect lines
      xpos2 = xpos;
      ypos2 = ypos;
      //animate image out
      float imageDist = 0 - imageSize;
      if (imageSize > 0) {
        imageSize = imageSize + imageDist/4;
      }
      if (imageSize < 4) {
        imageSize = 0;
      }
      // restore alpha channel
      alpha = 255;
    }
  }
 
   public void titleText(){
     textFont(titleFont);
     textAlign(CENTER);
     fill(c);
     rectMode(CORNER);
     text(title.trim(), 0, titleY); // Title Text
     textFont(nameFont);
     fill(darkGray);
     text(name.trim(), 0, titleY+30); // Name Text
     
     if (ifClicked == true){ // if channel is selected
       //animate text in
       float titleDistY = titleY2 - titleY;
       if (titleY > titleY2) {
         titleY = titleY + titleDistY/8;
       }
       if (titleDistY < 5){
         titleDistY = 0;
       }
     }
     if (ifClicked == false){ // if channel isn't selected
       float titleDistY = titleY2 - titleY-5;
       if (titleY < height-transY+100) {
         titleY = titleY - titleDistY/2;
       }
     }
     
   }
 
  public void mostWatched(){
    float triStartX = mostWatchedX+13;
    float triStartY = mostWatchedY+18;

    // rewind button
    fill(c);
    rectMode(CORNER);
    rect(mostWatchedX, mostWatchedY, 65, 37, 10);
    fill(0xffffffff);
    triangle(triStartX, triStartY, triStartX+15, triStartY-8, triStartX+15, triStartY+8);
    triangle(triStartX+20, triStartY, triStartX+15+20, triStartY-8, triStartX+15+20, triStartY+8);
    // text
    fill(c);
    textAlign(LEFT);
    textFont(av18Font);
    text("most watched video of 2013", (mostWatchedX), (mostWatchedY+55));
    fill(darkGray);
    textFont(av12BoldFont);
    text(mostWatchedViews + " views", (mostWatchedX), (mostWatchedY+55+15));
    textLeading(12);
    textFont(av12Font);
    text(mostWatchedName, (mostWatchedX), (mostWatchedY+55+22), 250, 100);
    
    if (ifClicked == true) { // if channel is selected
      float watchedDistX = mostWatchedX-mostWatchedX2;
      // animate mostWatched in from left
      if (mostWatchedX < mostWatchedX2) { // final position
        mostWatchedX = mostWatchedX - watchedDistX/8;
      }
      if (watchedDistX < 5) {
        watchedDistX = 0;
      }
    }
    if (ifClicked == false) { // if channel isn't selected
      float watchedDistX = mostWatchedX-(-transX-500);
      if(mostWatchedX > -transX-500) {
        mostWatchedX = mostWatchedX - watchedDistX/8;
      }
    }
    
  }
  
  public void disable(){
    // hide channel details to show next  
    ifClicked = false;
  }
  

}
public void mouseClicked(){
  
  // CHECK IF CHANNELS HAVE BEEN CLICKED
  for (int i = 0; i < channels.length; i++) {
    if(mouseX > channelObjects[i].xpos+transX-(channelObjects[i].r2/2)) {
        if (mouseX < channelObjects[i].xpos+transX+(channelObjects[i].r2/2)){
          if(mouseY > channelObjects[i].ypos+transY-(channelObjects[i].r2/2)){
            if (mouseY < channelObjects[i].ypos+transY+(channelObjects[i].r2/2)){
              for (int k = 0; k < channels.length; k++) {
                //if any channels are reversed, change them back
                channelObjects[k].reverse = false;
              }
              if (anyClicked == true) { // if channel details are displayed, close out that channel before opening next
                cConnectString.clear(); // clear connection strings
                for (int k = 0; k < channels.length; k++) {
                  if (channelObjects[k].ifClicked == true) { // check for the clicked channel
                    channelObjects[k].disable();
                    for (int n = 0; n < connectionLines.size(); n++){ // restore connections
                      Connection connection = connectionLines.get(n);
                           connection.showConnection = true;
                           fill(0xffffffff);
                           ellipse(transX, transY, radius, radius); // circle to hide returning connections
                    }
                    fill(0xffffffff);
                    ellipse(transX, transY, radius, radius); // circle to hide returning connections
                    channelObjects[i].onClick();
                    channelObjects[i].ifClicked = true;
                  }
                }
              }
              if (anyClicked == false) { // if channel details aren't displayed
                channelObjects[i].onClick();
                channelObjects[i].ifClicked = true;
              }  
            } else {}
          } else {}
        } else {}
        } else {}
    
  }
  
  // check if returnBtn has been clicked
  for (int i = 0; i < channels.length; i++){
    float distX = sq((channelObjects[i].returnBtn.x+transX) - mouseX);
    float distY = sq((channelObjects[i].returnBtn.y+transY) - mouseY);
    if ((distX + distY) <= sq(channelObjects[i].returnBtn.d/2)){
     // close out current channel 
     cConnectString.clear(); // clear connection strings
     if (channelObjects[i].ifClicked == true) { // check for the clicked channel
       channelObjects[i].disable();
       for (int n = 0; n < connectionLines.size(); n++){ // restore connections
         Connection connection = connectionLines.get(n);
         connection.showConnection = true;
       }
       channelObjects[i].ifClicked = false;
       anyClicked = false;
     }
     // move title back
     moveTitle = true;
    }
    
  }
     
    // check if most watched button was clicked
    // rect(mostWatchedX, mostWatchedY, 140, 80, 10);
    for (int i = 0; i < channels.length; i++){
      if (mouseX > channelObjects[i].mostWatchedX+transX) {
        if (mouseX < channelObjects[i].mostWatchedX+140+transX) {
          if (mouseY > channelObjects[i].mostWatchedY+transY){
            if (mouseY < channelObjects[i].mostWatchedY+80+transY){
              link(channelObjects[i].URL);
            }
          }
        }
      }
    
    }
    
    // check if connection legend was clicked
    if (instructions.tierAllOn == true) { // show all connections
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         connection.showConnection = true;
       }
       for (int n=0; n < channels.length; n++) {
          channelObjects[n].reverse = false;
      }
    }
    if (instructions.tier1On == true) { // show tier 1 connections
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         if (connection.tier == 1) {
           connection.showConnection = true;
         } else {
           connection.showConnection = false;
         }
       }
       for (int n=0; n < channels.length; n++) {
          channelObjects[n].reverse = false;
      }
    }
    if (instructions.tier2On == true) { // show tier 2 connections
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         if (connection.tier == 2) {
           connection.showConnection = true;
         } else {
           connection.showConnection = false;
         }
       }
       for (int n=0; n < channels.length; n++) {
          channelObjects[n].reverse = false;
      }
    }
    if (instructions.catAll.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         connection.showConnection = true;
       }
       for (int n=0; n < channels.length; n++) {
          channelObjects[n].reverse = false;
      }
    }
    if (instructions.catVlog.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == vlogC || channelObjects[connection.person2].c == vlogC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == vlogC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    if (instructions.catCooking.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == cookingC || channelObjects[connection.person2].c == cookingC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == cookingC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    if (instructions.catGamer.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == gamerC || channelObjects[connection.person2].c == gamerC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == gamerC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    if (instructions.catMusic.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == musicC || channelObjects[connection.person2].c == musicC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == musicC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    if (instructions.catDance.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == danceC || channelObjects[connection.person2].c == danceC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == danceC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    if (instructions.catEnt.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == entC || channelObjects[connection.person2].c == entC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == entC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    if (instructions.catOther.catOn == true) {
      for (int n = 0; n < connectionLines.size(); n++){ 
         Connection connection = connectionLines.get(n);
         for (int i = 0; i < channels.length; i++) {
           if (channelObjects[connection.person1].c == otherC || channelObjects[connection.person2].c == otherC) {
             connection.showConnection = true;
           } else {
             connection.showConnection = false;
           }
         
         }
       }
       for (int n=0; n < channels.length; n++) {
        if (channelObjects[n].c == otherC) {
          channelObjects[n].reverse = false;
        } else {
          channelObjects[n].reverse = true;
        }
      }
    }
    //check for rewind button
    if (instructions.rewindOn == true) {
      link("http://www.youtube.com/watch?v=H7jtC8vjXw8");
    }
    
     
}
class ReturnBtn {
  boolean returnOn;
  float x;
  float y;
  float d;
  float alpha;
  int c;
  float speed;
  
  Tooltip returnTip;
  
  ReturnBtn(int tempc){
    returnOn = false;
    x = 95;
    y = -95;
    d = 20;
    alpha = 0;
    c = tempc;
    speed = 15;
    
    returnTip = new Tooltip(x, y-20, "return", "center");
    
  }

  public void display(){
    smooth();
    fill(0xffffffff, alpha);
    stroke(c, alpha);
    ellipseMode(CENTER);
    ellipse(x, y, d, d);
    textAlign(CENTER, CENTER);
    noStroke();
    fill(c, alpha);
    text("x", x+1, y-2);

    returnTip.display();
    
    // fade in
    if (alpha < 255) {
      alpha = alpha + speed;
    }
    if (alpha > 255) {
      alpha = 255;
    }

    // if hovering, show tooltip
    float distX = sq((x+transX) - mouseX);
    float distY = sq((y+transY) - mouseY);
    if ((distX + distY) <= sq(d/2)){
      returnTip.onHover();
    } else {
      returnTip.offHover();
    }
    
  }

}
// Subscriber numbers are computed in the Youtuber class and used to create new SubBars

class SubBars{
  float x; // x coord
  float y; // y coord
  float w; // width
  float h; // scaling height
  float h2; // final height
  int channelC; // Channel color
  int c; // Bar color
  String content; // what kind of bar it is (high, low, average, channel)

  float subScale; // ratio to scale down the sub count
  float barStart; // where the sub bars start (y coord)
  float barWidth; // sub bar width + spacing
  
  float subCounter;
  
  Tooltip subTooltip; // subscription tooltip

  int subInt; // converts floats to ints so they can be used with nfc()
  String subString; // uses nfc() to add commas in proper spots

  float speed = 15;

  SubBars(int barNumber, float subCount, String tempcontent){
    
    barStart = 600 - transX;
    barWidth = 45;
    subCounter = subCount;
    subScale = 20000;
    
    x = barStart-(barWidth*barNumber);
    y = height-transY-40;
    h = 0; // scaling height
    h2 = -(subCounter/subScale); // final height
    w = 10;
    //channelC = tempc;
    content = tempcontent;
    
    subInt = PApplet.parseInt(subCounter);
    subString = nfc(subInt);
    
    if (content.equals("Lowest") || content.equals("Highest") || content.equals("Average")){
      c = lightGray;
    } else if (content.equals("Channel")){
      c = vlogC; // temp color
    }
  
    subTooltip = new Tooltip(x, mouseY, (" " + content + " Sub Count: " + subString + " "), "right");
  
  }

  public void display(){
    if (anyClicked == true) { // if any channels are selected
      // Declare again for changing variables
      h2 = -(subCounter/subScale); 
      subInt = PApplet.parseInt(subCounter);
      subString = nfc(subInt);
      subTooltip.tipText = (content + " Sub Count: " + subString);
      subTooltip.tipWidth = (textWidth(subTooltip.tipText)) + 20;
    
    // adjust for sub bars that go off the chart
    if (subCounter > 9000000) {
      h2 = -710-((subCounter/subScale)/50);
    }
    // adjust for sub bars that don't even show, they're so small
    if (subCounter < 1000){
      h2 = 1;
    }
    
      fill(c);
      noStroke();
      rectMode(CORNER);
      rect(x, y, w, h);
      // if sub bar goes off chart, draw cut-off line
      if (subCounter > 9000000) {
        stroke(0xffffffff);
        strokeWeight(5);
        strokeJoin(MITER);
        beginShape();
        vertex(x-1, (y+h2+20));
        vertex((x+w+2), (y+h2+25));
        endShape();
      }
      
      textAlign(CENTER);
      textFont(av12Font);
      text(content.toLowerCase(), (x+w/2), (y+h-5));
    
      animate();
    
      subTooltip.display();
      // update tooltip Y
      subTooltip.y = mouseY - transY - 25;
    
    }
  
    // Mouse needs a little extra room to hover for the really skinny bars
    if (mouseX > (x+transX)){
      if (mouseX < x+w+transX) {
       if (mouseY > y+h+transY-5) {
         if (mouseY < y+transY+5){
           // hovering
           onHover();
         } else {offHover();}
       } else {offHover();}
      } else {offHover();}
    } else {offHover();}
    
  }
  
  public void onHover(){
    subTooltip.onHover(); 
  }
  
  public void offHover(){
    subTooltip.offHover();
  }
  
  public void animate(){
    // animate bar, slow down according to the distance
    if (h > h2) {
      float distY = h-h2;
      h = h - distY/8;
    }
    if (h < h2) {
      float distY = h2-h;
      h = h + distY/8;
    }
 
  }



}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--hide-stop", "youtube_rewind_jbarkun" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
